[leetcode] 746. Min Cost Climbing Stairs @ python

版权声明:版权归个人所有,未经博主允许,禁止转载 https://blog.csdn.net/danspace1/article/details/88661409

原题

On a staircase, the i-th step has some non-negative cost cost[i] assigned (0 indexed).

Once you pay the cost, you can either climb one or two steps. You need to find minimum cost to reach the top of the floor, and you can either start from the step with index 0, or the step with index 1.

Example 1:
Input: cost = [10, 15, 20]
Output: 15
Explanation: Cheapest is start on cost[1], pay that cost and go to the top.
Example 2:
Input: cost = [1, 100, 1, 1, 1, 100, 1, 1, 100, 1]
Output: 6
Explanation: Cheapest is start on cost[0], and only step on 1s, skipping cost[3].
Note:
cost will have a length in the range [2, 1000].
Every cost[i] will be an integer in the range [0, 999].

解法

动态规划. 构造数组dp, dp[i]表示到达i点的最少花费, 转态转移方程:

dp[i] = min(dp[i-2]+cost[i-2], dp[i-1]+cost[i-1])

由于我们可以从index 0或1起步, 因此dp[0] = dp[1] = 0, 最后要到台阶顶部, 因此dp长度需要比cost长度大1, 最后返回dp[-1]即可.
Time: O(n)
Space: O(n)

代码

class Solution(object):
    def minCostClimbingStairs(self, cost):
        """
        :type cost: List[int]
        :rtype: int
        """
        # base case
        if len(cost) <= 2:
            return min(cost)
        dp = [0]*(len(cost)+1)
        
        for i in range(2, len(dp)):
            dp[i] = min(dp[i-2]+cost[i-2], dp[i-1]+cost[i-1])
        return dp[-1]

猜你喜欢

转载自blog.csdn.net/danspace1/article/details/88661409